



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux设备驱动之IIO子系统——IIO框架数据读取</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux设备驱动之IIO子系统——IIO框架数据读取</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-28 02:04:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>IIO DATA ACCESS IIO</strong><strong>数据获取</strong></p>
<p>　　只有两种方法可以使用IIO框架访问数据; 通过sysf通道进行一次性捕获，或通过IIO字符设备进行连续模式（触发缓冲）。</p>
<p><strong>One-shot capture</strong><strong>：单次获取</strong></p>
<p>　　一次性数据捕获通过sysfs接口完成。 通过读取与通道对应的sysfs条目，您将仅捕获特定于该通道的数据。 给定一个带有两个通道的温度传感器：一个用于环境温度，另一个用于热电偶温度：</p>
<div>
<pre class="prettyprint linenums"># cd /sys/bus/iio/devices/iio:device0<br />
# cat in_voltage3_raw

# cat in_voltage_scale<br />
0.305175781</pre>
</div>
<p>　　通过将比例乘以原始值来获得处理值。</p>
<p>　　Voltage value: 6646 * 0.305175781 = 2028.19824053</p>
<p>　　器件数据表说过程值以mV给出。 在我们的例子中，它对应于2.02819V。</p>
<p><strong>Buffer data access</strong><strong>：缓冲区数据获取</strong></p>
<p>　　要使触发的采集工作，必须在驱动程序中实现触发器支持。 然后，要从用户空间内获取数据，必须：创建触发器，分配它，启用ADC通道，设置缓冲区的维度，并启用它。这里主要介绍两种：sysfs触发器和hrtimer触发器。</p>
<p><strong>使用sysfs触发器获取：</strong></p>
<p>　　使用sysfs触发器捕获数据包括发送一组命令少量sysfs文件。 让我们列举一下我们应该做些什么来实现这一目标：</p>
<p>1. 创建触发器：在将触发器分配给任何设备之前，应该创建它：</p>
<div>
<pre class="prettyprint linenums"># echo  &gt; /sys/devices/iio_sysfs_trigger/add_trigger</pre>
</div>
<p>这里，0对应于我们需要分配给触发器的索引。 在此命令之后，触发器目录将在/ sys / bus / iio / devices /下作为trigger0。</p>
<p>2. 将触发器分配给设备：触发器由其名称唯一标识，我们可以使用该触发器将设备绑定到触发器。 由于我们使用0作为索引，因此触发器将命名为sysfstrig0：</p>
<div>
<pre class="prettyprint linenums"># echo sysfstrig0 &gt; /sys/bus/iio/devices/iio:device0/trigger/current_t</pre>
</div>
<p>　　我们也可以使用下面这个命令：cat /sys/bus/iio/devices/trigger0/name&gt; /sys/bus/iio/devices/iio:device0/trigger/current_trigger. 也就是说，如果我们编写的值与现有的触发器名称不对应，则不会发生任何事情。 为了确保我们真正定义了一个触发器，我们可以使用cat/sys/bus/iio/devices/iio:device0/trigger/current_trigger.</p>
<p>3. 启用扫描元素：此步骤包括选择将其数据值推入缓冲区的通道。 应该注意驱动程序中的available_scan_masks：</p>
<div>
<pre class="prettyprint linenums"># echo  &gt; /sys/bus/iio/devices/iio:device0/scan_elements/in_voltage4_en<br />
 # echo  &gt; /sys/bus/iio/devices/iio:device0/scan_elements/in_voltage5_en<br />
 # echo  &gt; /sys/bus/iio/devices/iio:device0/scan_elements/in_voltage6_en<br />
 # echo  &gt; /sys/bus/iio/devices/iio:device0/scan_elements/in_voltage7_en</pre>
</div>
<p>4. 设置缓冲区大小：这里应该设置缓冲区可以保存的样本集数量：</p>
<div>
<pre class="prettyprint linenums"># echo  &gt; /sys/bus/iio/devices/iio:device0/buffer/length</pre>
</div>
<p>5. 启用缓冲区：此步骤包括将缓冲区标记为准备接收推送数据：</p>
<div>
<pre class="prettyprint linenums"># echo  &gt; /sys/bus/iio/devices/iio:device0/buffer/enable</pre>
</div>
<p>要停止捕获，我们必须在同一个文件中写入0。</p>
<p>6.使能触发器：启动采集：</p>
<div>
<pre class="prettyprint linenums"># echo  &gt; /sys/bus/iio/devices/trigger0/trigger_now</pre>
</div>
<p>现在数据获取已经完成，下一步我们可以</p>
<p>7. 禁用缓冲区：</p>
<div>
<pre class="prettyprint linenums"># echo  &gt; /sys/bus/iio/devices/iio:device0/buffer/enable</pre>
</div>
<p>8.分离触发器Detach the trigger:</p>
<div>
<pre class="prettyprint linenums">  # echo "" &gt; /sys/bus/iio/devices/iio:device0/trigger/current_trigger</pre>
</div>
<p>9.转储IIO字符设备的内容</p>
<p># cat /dev/iio\:device0 | xxd &ndash;</p>
<p><strong>使用hrtimer触发器获取（4.5及以上内核版本）</strong></p>
<p>　　以下是允许使用hrtimer触发器捕获数据的命令集：</p>
<div>
<pre class="prettyprint linenums"># echo /sys/kernel/config/iio/triggers/hrtimer/trigger0<br />
 # echo  &gt; /sys/bus/iio/devices/trigger0/sampling_frequency<br />
 # echo  &gt; /sys/bus/iio/devices/iio:device0/scan_elements/in_voltage4_en<br />
 # echo  &gt; /sys/bus/iio/devices/iio:device0/scan_elements/in_voltage5_en<br />
 # echo  &gt; /sys/bus/iio/devices/iio:device0/scan_elements/in_voltage6_en<br />
 # echo  &gt; /sys/bus/iio/devices/iio:device0/scan_elements/in_voltage7_en<br />
 # echo  &gt; /sys/bus/iio/devices/iio:device0/buffer/enable<br />
 # cat /dev/iio:device0 | xxd -

 :  1a30    68a8 c24f 5a14 .........h..OZ.<br />
  :  1a30   192d 98a9 c24f 5a14 ........-...OZ.<br />
  [...]</pre>
</div>
<p>然后，我们查看类型以确定如何处理数据：</p>
<div>
<pre class="prettyprint linenums">$ cat /sys/bus/iio/devices/iio:device0/scan_elements/in_voltage_type

be:s14/&gt;&gt;</pre>
</div>
<p>Voltage processing: 0x188 &gt;&gt; 2 = 98 * 250 = 24500 = 24.5 v</p>
<p><strong>IIO tools</strong></p>
<p>　　您可以使用一些有用的工具来简化和加快使用IIO设备开发应用程序的速度。 它们在内核树中的tools / iio中可用：</p>
<ul><li>lsiio.c：枚举IIO触发器，设备和通道</li>
<li>iio_event_monitor.c: 监视IIO设备的IIO事件的ioctl接口</li>
<li>generic_buffer.c: 检索，处理和打印从IIO设备缓冲区接收的数据</li>
<li>libiio: 一个功能强大的库，由模拟设备开发，用于接口IIO设备，可从https://github.com/analogdevicesinc/libiio获得。</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mdglp8.html">mysql刷日志的两个参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1plx5q.html">python 3&period;5 关于sys问题总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2r7xw9.html">【wikioi】1250 Fibonacci数列（矩阵乘法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx04mjq.html">利用 libiconv 实现汉字编码 utf-8 格式 和 gbk格式的相互转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xoln09.html">RadioGroup&plus;Fragment 使用Fragment的add（）方法，防止使用replace每次都重新加载页面，造成资源浪费</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdep7279.html">linux 大并发下 内核优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oemxj9.html">Ubuntu 14&period;04 64位安装Android Studio 和 genymotion （下）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xmkyr9.html">&lbrack;OpenJudge&rsqb; 百练2754 八皇后</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mngwmpq.html">TCP&sol;IP详解之：IP选路 动态选路协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zmy339.html">STM32开发指南-跑马灯实验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv10jvxq.html">Java设计模式之职责型模式总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zw06e9.html">SQL注入攻击三部曲之入门篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjpx049.html">Oauth2&period;0&lbrack;笔记&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj2grj9.html">Nginx优化详解-------超详细</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvox7k8.html">day 46 html 学习 列 表格，</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllyr11q.html">spring mvc 的请求流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emee2z9.html">配置nginx支持TP框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjdmvvq.html">WPF自定义控件的两种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1wkk19.html">hibernate、java、数据库对应类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpl6pz9.html">python 3 爬取百度图片</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4zlr2n9.html">MP3、MP4的文件选择及播放</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyznzm9.html">NET Core微服务之路：基于Ocelot的API网关Relay实现--RPC篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pv11y8.html">基于Java实现简化版本的布隆过滤器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp76pvq.html">Python网络爬虫与如何爬取段子的项目实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj6zne9.html">Android OpenSL ES 开发：Android OpenSL 录制 PCM 音频数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ym07g8.html">LeetCode题解38&period;Count and Say</a>
			</li>
						<li><a href="https://www.batexi.com/a/95025de8.html">macOS 10&period;14虚拟机安装教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k1gw09.html">Go语言反射reflect</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyzpve9.html">&lbrack;Swift&rsqb;LeetCode35&period; 搜索插入位置 &vert; Search Insert Position</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge21ll8.html">&lbrack;Swift&rsqb;LeetCode827&period; 最大人工岛 &vert; Making A Large Island</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
